Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class EagerLetExpression

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.Assignation
              net.sf.saxon.expr.LetExpression
                  net.sf.saxon.expr.EagerLetExpression

All Implemented Interfaces:
  Serializable, SourceLocator, Binding, Container, EvaluableItem, SequenceIterable, TailCallReturner, InstructionInfoProvider

    public class EagerLetExpression

extends LetExpression

An EagerLetExpression is the same as a LetExpression except that the variable is evaluated using eager evaluation rather than lazy evaluation. This is used when performing diagnostic tracing.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`EagerLetExpression()`

Method Summary
`Expression` | `optimize(Optimizer opt, StaticContext env, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.

Methods inherited from class net.sf.saxon.expr.LetExpression
`addReference, checkPermittedContents, computeCardinality, computeSpecialProperties, display, evaluateItem, getItemType, getNominalReferenceCount, isIndexedVariable, iterate, markTailFunctionCalls, process, processLeavingTail, promote, setIndexedVariable, typeCheck`

Methods inherited from class net.sf.saxon.expr.Assignation
`evaluateVariable, getAction, getLocalSlotNumber, getRequiredSlots, getSequence, getVariableDeclaration, getVariableFingerprint, getVariableName, getVariableNameCode, isAssignable, isGlobal, iterateSubExpressions, replaceSubExpression, setAction, setSequence, setSlotNumber, setVariableDeclaration, simplify, suppressValidation`

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, computeDependencies, computeStaticProperties, doPromotion, effectiveBooleanValue, evaluateAsString, getCardinality, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, resetStaticProperties, setLocationId, setParentExpression, setParentExpression`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### EagerLetExpression

    public EagerLetExpression()

Method Detail

### optimize

    public Expression optimize(Optimizer opt,
                               StaticContext env,
                               ItemType contextItemType)
                        throws XPathException

  Description copied from class: `LetExpression`
  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `LetExpression`
  Parameters:
    `opt` - the optimizer in use. This provides access to supporting functions; it also allows different optimization strategies to be used in different circumstances.
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.